{
	T7F - A program to read and set T7F channels
	Copyright (C) 2000 Giuseppe Perotti, I1EPJ

	The T7F is a 70 cm FM/FSK Transceiver by Holger Eckardt, DF2FQ

	This program uses the TCOMMPORTDRIVER component:
		(C) 1997 by Marco Cocco. Tutti i diritti riservati.
		(C) 1997 by d3k. Tutti i diritti riservati.

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
}

unit T7fu1;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Menus, Mask, ComDrv16, Hexd, T7FAbout, GNULic,
  T7Pinout;

const OneSec = 1/86400;

type
  TForm1 = class(TForm)
	 Label1: TLabel;
	 Label2: TLabel;
	 Label3: TLabel;
	 Label4: TLabel;
	 Label5: TLabel;
	 Label6: TLabel;
	 Label7: TLabel;
	 Label8: TLabel;
	 Label9: TLabel;
	 Label10: TLabel;
	 MainMenu1: TMainMenu;
	 Label11: TLabel;
	 Label12: TLabel;
	 File1: TMenuItem;
    Load1: TMenuItem;
	 Save1: TMenuItem;
	 Exit1: TMenuItem;
	 T7F1: TMenuItem;
	 Readsetup1: TMenuItem;
    WriteChanToT7F1: TMenuItem;
    Help1: TMenuItem;
    About1: TMenuItem;
	 ComPort1: TMenuItem;
	 COM11: TMenuItem;
	 COM21: TMenuItem;
	 COM31: TMenuItem;
	 COM41: TMenuItem;
    OpenDialog1: TOpenDialog;
	 SaveDialog1: TSaveDialog;
	 HexDump1: TMenuItem;
	 Rx0: TMaskEdit;
    Tx0: TMaskEdit;
    Rx1: TMaskEdit;
	 Tx1: TMaskEdit;
    Rx2: TMaskEdit;
	 Tx2: TMaskEdit;
	 Rx3: TMaskEdit;
	 Tx3: TMaskEdit;
	 Rx4: TMaskEdit;
    Tx4: TMaskEdit;
    Rx5: TMaskEdit;
    Tx5: TMaskEdit;
	 Rx6: TMaskEdit;
    Tx6: TMaskEdit;
	 Rx7: TMaskEdit;
	 Tx7: TMaskEdit;
	 Rx8: TMaskEdit;
	 Tx8: TMaskEdit;
	 Rx9: TMaskEdit;
    Tx9: TMaskEdit;
    ChannelSpacing1: TMenuItem;
    N125kHz1: TMenuItem;
	 N25kHz1: TMenuItem;
    GNULicense1: TMenuItem;
    Connectorspinout1: TMenuItem;
    CommPortDriver1: TCommPortDriver;
    procedure CommPortDriver1ReceiveData(Sender: TObject; DataPtr: Pointer;
	   DataSize: Integer);
	 procedure COM11Click(Sender: TObject);
	 procedure COM21Click(Sender: TObject);
	 procedure COM31Click(Sender: TObject);
    procedure COM41Click(Sender: TObject);
	 procedure Readsetup1Click(Sender: TObject);
    procedure WriteChanToT7F1Click(Sender: TObject);
	 procedure Exit1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
	 procedure Rx0Enter(Sender: TObject);
	 procedure Tx0Enter(Sender: TObject);
	 procedure Rx1Enter(Sender: TObject);
    procedure Tx1Enter(Sender: TObject);
	 procedure Rx2Enter(Sender: TObject);
    procedure Tx2Enter(Sender: TObject);
	 procedure Rx3Enter(Sender: TObject);
	 procedure Tx3Enter(Sender: TObject);
	 procedure Rx4Enter(Sender: TObject);
	 procedure Tx4Enter(Sender: TObject);
	 procedure Rx5Enter(Sender: TObject);
	 procedure Tx5Enter(Sender: TObject);
	 procedure Rx6Enter(Sender: TObject);
	 procedure Tx6Enter(Sender: TObject);
	 procedure Rx7Enter(Sender: TObject);
	 procedure Tx7Enter(Sender: TObject);
	 procedure Rx8Enter(Sender: TObject);
	 procedure Tx8Enter(Sender: TObject);
	 procedure Rx9Enter(Sender: TObject);
	 procedure Tx9Enter(Sender: TObject);
	 procedure N125kHz1Click(Sender: TObject);
	 procedure N25kHz1Click(Sender: TObject);
	 procedure Load1Click(Sender: TObject);
	 procedure Save1Click(Sender: TObject);
	 procedure CheckFreq(EdBox: TMaskEdit);
	 procedure Rx0Exit(Sender: TObject);
	 procedure Tx0Exit(Sender: TObject);
	 procedure Rx1Exit(Sender: TObject);
	 procedure Tx1Exit(Sender: TObject);
	 procedure HexDump1Click(Sender: TObject);
	 procedure About1Click(Sender: TObject);
    procedure Rx2Exit(Sender: TObject);
    procedure Tx2Exit(Sender: TObject);
    procedure Rx3Exit(Sender: TObject);
    procedure Tx3Exit(Sender: TObject);
    procedure Rx4Exit(Sender: TObject);
	 procedure Tx4Exit(Sender: TObject);
    procedure Rx5Exit(Sender: TObject);
    procedure Tx5Exit(Sender: TObject);
    procedure Rx6Exit(Sender: TObject);
	 procedure Tx6Exit(Sender: TObject);
    procedure Rx7Exit(Sender: TObject);
    procedure Tx7Exit(Sender: TObject);
    procedure Rx8Exit(Sender: TObject);
    procedure Tx8Exit(Sender: TObject);
    procedure Rx9Exit(Sender: TObject);
    procedure Tx9Exit(Sender: TObject);
    procedure GNULicense1Click(Sender: TObject);
    procedure Connectorspinout1Click(Sender: TObject);
    procedure FormResize(Sender: TObject);

  private
	 { Private declarations }
	 procedure ReadChannels;
	 function ParseChannels: Boolean;
	 procedure DisplayChannels;
	 procedure GetFreq;
	 procedure SaveConfig;

  public
	 { Public declarations }
  end;

  TRxTxCh = array[0..9] of integer;

  TChanConf = record
		ChanSpc: integer;
		RxCh: TRxTxCh;
		TxCh: TRxTxCh;
  end;

var
  Form1: TForm1;
  RxBuf: array[0..255] of char;
  ps,pd: pchar;
  RxCh, TXCh: TRxTxCh;
  ChanSpc: integer;
  ChanConf: TChanConf;
  DataReceived: boolean;

implementation

{$R *.DFM}

{
	Com port driver RX upcall
}
procedure TForm1.CommPortDriver1ReceiveData(Sender: TObject;
  DataPtr: Pointer; DataSize: Integer);

var n:integer;

begin
	n := 0;
	ps := DataPtr;
	while Datasize > 0 do begin
		pd^ := ps^;
		inc(n);
		inc(ps);
		inc(pd);
		dec(Datasize);
	end;
end;

{
	Select COM1
}
procedure TForm1.COM11Click(Sender: TObject);
begin
	CommPortDriver1.Disconnect;
	CommPortDriver1.ComPort := pnCOM1;
	If not CommPortDriver1.Connect then begin
		Application.MessageBox('Can''t open COM1:','Error!',MB_ICONSTOP or MB_OK);
	end;
	Com11.Checked := True;
	Com21.Checked := False;
	Com31.Checked := False;
	Com41.Checked := False;
	SaveConfig;
end;

{
	Select COM2
}
procedure TForm1.COM21Click(Sender: TObject);
begin
	CommPortDriver1.Disconnect;
	CommPortDriver1.ComPort := pnCOM2;
	If not CommPortDriver1.Connect then begin
		Application.MessageBox('Can''t open COM2','Errore!',MB_ICONSTOP or MB_OK);
	end;
	Com11.Checked := False;
	Com21.Checked := True;
	Com31.Checked := False;
	Com41.Checked := False;
	SaveConfig;
end;

{
	Select COM3
}
procedure TForm1.COM31Click(Sender: TObject);
begin
	CommPortDriver1.Disconnect;
	CommPortDriver1.ComPort := pnCOM3;
	If not CommPortDriver1.Connect then begin
		Application.MessageBox('Can''t open COM3','Errore!',MB_ICONSTOP or MB_OK);
	end;
	Com11.Checked := False;
	Com21.Checked := False;
	Com31.Checked := True;
	Com41.Checked := False;
	SaveConfig;
end;

{
	Select COM4
}
procedure TForm1.COM41Click(Sender: TObject);
begin
	CommPortDriver1.Disconnect;
	CommPortDriver1.ComPort := pnCOM4;
	If not CommPortDriver1.Connect then begin
		Application.MessageBox('Can''t open COM4','Errore!',MB_ICONSTOP or MB_OK);
	end;
	Com11.Checked := False;
	Com21.Checked := False;
	Com31.Checked := False;
	Com41.Checked := True;
	SaveConfig;
end;

{
	Save configuration data (COM port number and default channel spacing)
}
procedure Tform1.SaveConfig;

var ConfFile: FILE of integer;
	 comport: integer;

begin
	{$I-}
	AssignFile(ConfFile, 'T7F.INI');
	Rewrite(ConfFile);
	if IOResult = 0 then begin
		comport := integer(CommPortDriver1.ComPort);
		Write(ConfFile, comport);
		Write(ConfFile, ChanSpc);
		CloseFile(ConfFile);
	end else begin
		Application.MessageBox('Can''t write configuration file',
			'Errore!',MB_ICONSTOP or MB_OK);
	end;
end;

{
	Read channel assignment for T7F
	Issue an E command then wait 2s to allow response to come in
}
procedure Tform1.ReadChannels;

var t: TDateTime;

begin
	pd := RxBuf;
	FillChar(RxBuf,256,0);
	CommPortDriver1.SendString('E');
	t := Now;
	repeat
		Application.ProcessMessages;
	until (Now-t) > 2*OneSec;
end;

{
	Parse T7F channel hex dump
	(10 lines of the form ' tttt rrrr' where
		tttt is the transmit divisor
		rrrr is the receive divisor
}
function Tform1.ParseChannels: Boolean;

var n: integer;
	 p: pchar;

{ Convert a 4 digit hex number starting at pch to integer }
function Convhex4(pch: pchar):integer;

var n,res,digit: integer;
	 p1: pchar;

begin
	p1 := pch;
	res := 0;
	for n := 0 to 3 do begin
		if ord(p1^) <= ord('9') then begin
			digit := ord(p1^) - ord('0');
		end else begin
			digit := ord(p1^) - ord('A') + 10;
		end;
		res := 16*res+digit;
		inc(p1);
	end;
	ConvHex4 := res;
end;

begin
	if StrLen(RxBuf) = 112 then begin
		p := RxBuf;
		for n := 0 to 9 do begin
			while (p^=' ') or (p^=chr(13)) or (p^=chr(10)) or (p^='E') do inc(p);
			TxCh[n] := ConvHex4(p);
			inc(p,4);
			while (p^=' ') or (p^=chr(13)) or (p^=chr(10)) or (p^='E') do inc(p);
			RxCh[n] := ConvHex4(p);
			inc(p,4);
		end;
		ParseChannels := True;
	end else begin
		Application.MessageBox('T7F not responding!','Warning', MB_OK);
		ParseChannels := False;
	end;
end;

{
	Display channels assignment
}
procedure Tform1.DisplayChannels;

var MHz, kHz, Hz, fr: longint;
	 s: string;

{ Converts divisor value to frequency.
  All frequencies troughout the program are expressed in Hz }
function DivToFreq(divisor: integer): LongInt;

begin
	DivToFreq := 430000000 + LongInt(divisor)*LongInt(ChanSpc);
end;

begin
		fr := DivToFreq(RxCh[0]);
		MHz := fr div 1000000;
		kHz := (fr mod 1000000) div 1000;
		Hz := (fr mod 1000) div 100;
		FmtStr(s, '%3d.%3.3d.%1d',[MHz,kHz,Hz]);
		Rx0.Text := s;
		fr := DivToFreq(TxCh[0]);
		MHz := fr div 1000000;
		kHz := (fr mod 1000000) div 1000;
		Hz := (fr mod 1000) div 100;
		FmtStr(s, '%3d.%3.3d.%1d',[MHz,kHz,Hz]);
		Tx0.Text := s;

		fr := DivToFreq(RxCh[1]);
		MHz := fr div 1000000;
		kHz := (fr mod 1000000) div 1000;
		Hz := (fr mod 1000) div 100;
		FmtStr(s, '%3d.%3.3d.%1d',[MHz,kHz,Hz]);
		Rx1.Text := s;
		fr := DivToFreq(TxCh[1]);
		MHz := fr div 1000000;
		kHz := (fr mod 1000000) div 1000;
		Hz := (fr mod 1000) div 100;
		FmtStr(s, '%3d.%3.3d.%1d',[MHz,kHz,Hz]);
		Tx1.Text := s;

		fr := DivToFreq(RxCh[2]);
		MHz := fr div 1000000;
		kHz := (fr mod 1000000) div 1000;
		Hz := (fr mod 1000) div 100;
		FmtStr(s, '%3d.%3.3d.%1d',[MHz,kHz,Hz]);
		Rx2.Text := s;
		fr := DivToFreq(TxCh[2]);
		MHz := fr div 1000000;
		kHz := (fr mod 1000000) div 1000;
		Hz := (fr mod 1000) div 100;
		FmtStr(s, '%3d.%3.3d.%1d',[MHz,kHz,Hz]);
		Tx2.Text := s;

		fr := DivToFreq(RxCh[3]);
		MHz := fr div 1000000;
		kHz := (fr mod 1000000) div 1000;
		Hz := (fr mod 1000) div 100;
		FmtStr(s, '%3d.%3.3d.%1d',[MHz,kHz,Hz]);
		Rx3.Text := s;
		fr := DivToFreq(TxCh[3]);
		MHz := fr div 1000000;
		kHz := (fr mod 1000000) div 1000;
		Hz := (fr mod 1000) div 100;
		FmtStr(s, '%3d.%3.3d.%1d',[MHz,kHz,Hz]);
		Tx3.Text := s;

		fr := DivToFreq(RxCh[4]);
		MHz := fr div 1000000;
		kHz := (fr mod 1000000) div 1000;
		Hz := (fr mod 1000) div 100;
		FmtStr(s, '%3d.%3.3d.%1d',[MHz,kHz,Hz]);
		Rx4.Text := s;
		fr := DivToFreq(TxCh[4]);
		MHz := fr div 1000000;
		kHz := (fr mod 1000000) div 1000;
		Hz := (fr mod 1000) div 100;
		FmtStr(s, '%3d.%3.3d.%1d',[MHz,kHz,Hz]);
		Tx4.Text := s;

		fr := DivToFreq(RxCh[5]);
		MHz := fr div 1000000;
		kHz := (fr mod 1000000) div 1000;
		Hz := (fr mod 1000) div 100;
		FmtStr(s, '%3d.%3.3d.%1d',[MHz,kHz,Hz]);
		Rx5.Text := s;
		fr := DivToFreq(TxCh[5]);
		MHz := fr div 1000000;
		kHz := (fr mod 1000000) div 1000;
		Hz := (fr mod 1000) div 100;
		FmtStr(s, '%3d.%3.3d.%1d',[MHz,kHz,Hz]);
		Tx5.Text := s;

		fr := DivToFreq(RxCh[6]);
		MHz := fr div 1000000;
		kHz := (fr mod 1000000) div 1000;
		Hz := (fr mod 1000) div 100;
		FmtStr(s, '%3d.%3.3d.%1d',[MHz,kHz,Hz]);
		Rx6.Text := s;
		fr := DivToFreq(TxCh[6]);
		MHz := fr div 1000000;
		kHz := (fr mod 1000000) div 1000;
		Hz := (fr mod 1000) div 100;
		FmtStr(s, '%3d.%3.3d.%1d',[MHz,kHz,Hz]);
		Tx6.Text := s;

		fr := DivToFreq(RxCh[7]);
		MHz := fr div 1000000;
		kHz := (fr mod 1000000) div 1000;
		Hz := (fr mod 1000) div 100;
		FmtStr(s, '%3d.%3.3d.%1d',[MHz,kHz,Hz]);
		Rx7.Text := s;
		fr := DivToFreq(TxCh[7]);
		MHz := fr div 1000000;
		kHz := (fr mod 1000000) div 1000;
		Hz := (fr mod 1000) div 100;
		FmtStr(s, '%3d.%3.3d.%1d',[MHz,kHz,Hz]);
		Tx7.Text := s;

		fr := DivToFreq(RxCh[8]);
		MHz := fr div 1000000;
		kHz := (fr mod 1000000) div 1000;
		Hz := (fr mod 1000) div 100;
		FmtStr(s, '%3d.%3.3d.%1d',[MHz,kHz,Hz]);
		Rx8.Text := s;
		fr := DivToFreq(TxCh[8]);
		MHz := fr div 1000000;
		kHz := (fr mod 1000000) div 1000;
		Hz := (fr mod 1000) div 100;
		FmtStr(s, '%3d.%3.3d.%1d',[MHz,kHz,Hz]);
		Tx8.Text := s;

		fr := DivToFreq(RxCh[9]);
		MHz := fr div 1000000;
		kHz := (fr mod 1000000) div 1000;
		Hz := (fr mod 1000) div 100;
		FmtStr(s, '%3d.%3.3d.%1d',[MHz,kHz,Hz]);
		Rx9.Text := s;
		fr := DivToFreq(TxCh[9]);
		MHz := fr div 1000000;
		kHz := (fr mod 1000000) div 1000;
		Hz := (fr mod 1000) div 100;
		FmtStr(s, '%3d.%3.3d.%1d',[MHz,kHz,Hz]);
		Tx9.Text := s;
end;

{
	Read, parse and display channel data from T7F
}
procedure TForm1.ReadSetup1Click(Sender: TObject);

begin
	ReadChannels;
	if ParseChannels then begin
		DisplayChannels;
	end;
end;

{
	Get new frequency informations from controls
}
procedure Tform1.GetFreq;

{ Convert MHz,kHz and Hz data to frequency.
  All frequencies troughout the program are expressed in Hz }
function ReadFreq(f: string): longint;

var Errc: integer;
	 MHz, kHz, Hz, fr: longint;

begin
	Val(Copy(f, 1, 3), MHz, ErrC);
	Val(Copy(f, 5, 3), kHz, ErrC);
	Val(Copy(f, 9, 1), Hz, ErrC);
	fr := 1000000*MHz+1000*kHz+100*Hz;
	ReadFreq := fr;
end;

begin
	RxCh[0] := (ReadFreq(Rx0.Text)-430000000) div ChanSpc;
	TxCh[0] := (ReadFreq(Tx0.text)-430000000) div ChanSpc;
	RxCh[1] := (ReadFreq(Rx1.Text)-430000000) div ChanSpc;
	TxCh[1] := (ReadFreq(Tx1.text)-430000000) div ChanSpc;
	RxCh[2] := (ReadFreq(Rx2.Text)-430000000) div ChanSpc;
	TxCh[2] := (ReadFreq(Tx2.text)-430000000) div ChanSpc;
	RxCh[3] := (ReadFreq(Rx3.Text)-430000000) div ChanSpc;
	TxCh[3] := (ReadFreq(Tx3.text)-430000000) div ChanSpc;
	RxCh[4] := (ReadFreq(Rx4.Text)-430000000) div ChanSpc;
	TxCh[4] := (ReadFreq(Tx4.text)-430000000) div ChanSpc;
	RxCh[5] := (ReadFreq(Rx5.Text)-430000000) div ChanSpc;
	TxCh[5] := (ReadFreq(Tx5.text)-430000000) div ChanSpc;
	RxCh[6] := (ReadFreq(Rx6.Text)-430000000) div ChanSpc;
	TxCh[6] := (ReadFreq(Tx6.text)-430000000) div ChanSpc;
	RxCh[7] := (ReadFreq(Rx7.Text)-430000000) div ChanSpc;
	TxCh[7] := (ReadFreq(Tx7.text)-430000000) div ChanSpc;
	RxCh[8] := (ReadFreq(Rx8.Text)-430000000) div ChanSpc;
	TxCh[8] := (ReadFreq(Tx8.text)-430000000) div ChanSpc;
	RxCh[9] := (ReadFreq(Rx9.Text)-430000000) div ChanSpc;
	TxCh[9] := (ReadFreq(Tx9.text)-430000000) div ChanSpc;
end;

{
	Write channel informations to T7F
}
procedure TForm1.WriteChanToT7F1Click(Sender: TObject);

var n,nc: integer;
	buf: string[20];
	t: TDateTime;

 begin
	GetFreq;
	for n := 0 to 9 do begin
		FmtStr(buf, 'C%d%3.3d%3.3d%s',[n,TxCh[n],RxCh[n],chr(13)]);
		case n of
			0: begin label1.color := clRED; end;
			1: begin label2.color := clRED; label1.color := clBtnFace end;
			2: begin label3.color := clRED; label2.color := clBtnFace end;
			3: begin label4.color := clRED; label3.color := clBtnFace end;
			4: begin label5.color := clRED; label4.color := clBtnFace end;
			5: begin label6.color := clRED; label5.color := clBtnFace end;
			6: begin label7.color := clRED; label6.color := clBtnFace end;
			7: begin label8.color := clRED; label7.color := clBtnFace end;
			8: begin label9.color := clRED; label8.color := clBtnFace end;
			9: begin label10.color := clRED; label9.color := clBtnFace end;
		end;
		for nc := 1 to Length(buf) do begin
			CommPortDriver1.SendString(Copy(buf,nc,1));
			t := now;
			repeat
			   Application.ProcessMessages;
			until (now-t) > OneSec/10;
		end;
		t := now;
		repeat
			Application.ProcessMessages;
		until (now-t) > OneSec/4;
	end;
	if n=9 then label10.color := clBtnFace;
end;

{
	Exit program
}
procedure TForm1.Exit1Click(Sender: TObject);
begin
	Halt;
end;

{
	Things to do at startup
		- read COM port number from configuration file
		  and setup menus to reflect configuration
		- open selected COM port
		- read, parse and display channel assignment
}
procedure TForm1.FormCreate(Sender: TObject);

var ConfFile: FILE of integer;
	 comport: integer;
	 sz: array[0..20] of char;

begin
	AssignFile(ConfFile,'T7F.INI');
	{$I-}
	Reset(ConfFile);
	if IOResult = 0 then begin
		Read(ConfFile,comport);
		Read(ConfFile,ChanSpc);
		CloseFile(ConfFile);
		CommPortDriver1.ComPort := TComPortNumber(comport);
	end else begin
		comport := integer(pnCOM1);
		CommPortDriver1.ComPort := pnCOM1;
		SaveConfig;
	end;
	case CommPortDriver1.ComPort of
		pnCOM1: begin
			Com11.Checked := TRUE;
			Com21.Checked := FALSE;
			Com31.Checked := FALSE;
			Com41.Checked := FALSE;
		end;
		pnCOM2: begin
			Com11.Checked := FALSE;
			Com21.Checked := TRUE;
			Com31.Checked := FALSE;
			Com41.Checked := FALSE;
		end;
		pnCOM3: begin
			Com11.Checked := FALSE;
			Com21.Checked := FALSE;
			Com31.Checked := TRUE;
			Com41.Checked := FALSE;
		end;
		pnCOM4: begin
			Com11.Checked := FALSE;
			Com21.Checked := FALSE;
			Com31.Checked := FALSE;
			Com41.Checked := TRUE;
		end;
	end;
	if ChanSpc = 25000 then begin
		N125kHz1.Checked := False;
		N25kHz1.Checked := True;
	end else begin
		N125kHz1.Checked := True;
		N25kHz1.Checked := False;
	end;
	If not CommPortDriver1.Connect then begin
		StrFmt(sz, 'Can''t open COM%d',[ord(comport)+1]);
		Application.MessageBox(sz,'Error!',MB_ICONSTOP or MB_OK);
	end;
	ReadChannels;
	if ParseChannels then begin
		DisplayChannels;
	end;
end;

{
	Things to do when entering Rx and TX frequency edit boxes
}
procedure TForm1.Rx0Enter(Sender: TObject);
begin
	Rx0.SelStart := 2;
	Rx0.SelLength := 1;
end;

procedure TForm1.Tx0Enter(Sender: TObject);
begin
	Tx0.SelStart := 2;
	Tx0.SelLength := 1;
end;

procedure TForm1.Rx1Enter(Sender: TObject);
begin
	Rx1.SelStart := 2;
	Rx1.SelLength := 1;
end;

procedure TForm1.Tx1Enter(Sender: TObject);
begin
	Tx1.SelStart := 2;
	Tx1.SelLength := 1;
end;

procedure TForm1.Rx2Enter(Sender: TObject);
begin
	Rx2.SelStart := 2;
	Rx2.SelLength := 1;
end;

procedure TForm1.Tx2Enter(Sender: TObject);
begin
	Tx2.SelStart := 2;
	Tx2.SelLength := 1;
end;

procedure TForm1.Rx3Enter(Sender: TObject);
begin
	Rx3.SelStart := 2;
	Rx3.SelLength := 1;
end;

procedure TForm1.Tx3Enter(Sender: TObject);
begin
	Tx3.SelStart := 2;
	Tx3.SelLength := 1;
end;

procedure TForm1.Rx4Enter(Sender: TObject);
begin
	Rx4.SelStart := 2;
	Rx4.SelLength := 1;
end;

procedure TForm1.Tx4Enter(Sender: TObject);
begin
	Tx4.SelStart := 2;
	Tx4.SelLength := 1;
end;

procedure TForm1.Rx5Enter(Sender: TObject);
begin
	Rx5.SelStart := 2;
	Rx5.SelLength := 1;
end;

procedure TForm1.Tx5Enter(Sender: TObject);
begin
	Tx5.SelStart := 2;
	Tx5.SelLength := 1;
end;

procedure TForm1.Rx6Enter(Sender: TObject);
begin
	Rx6.SelStart := 2;
	Rx6.SelLength := 1;
end;

procedure TForm1.Tx6Enter(Sender: TObject);
begin
	Tx6.SelStart := 2;
	Tx6.SelLength := 1;
end;

procedure TForm1.Rx7Enter(Sender: TObject);
begin
	Rx7.SelStart := 2;
	Rx7.SelLength := 1;
end;

procedure TForm1.Tx7Enter(Sender: TObject);
begin
	Tx7.SelStart := 2;
	Tx7.SelLength := 1;
end;

procedure TForm1.Rx8Enter(Sender: TObject);
begin
	Rx8.SelStart := 2;
	Rx8.SelLength := 1;
end;

procedure TForm1.Tx8Enter(Sender: TObject);
begin
	Tx8.SelStart := 2;
	Tx8.SelLength := 1;
end;

procedure TForm1.Rx9Enter(Sender: TObject);
begin
	Rx9.SelStart := 2;
	Rx9.SelLength := 1;
end;

procedure TForm1.Tx9Enter(Sender: TObject);
begin
	Tx9.SelStart := 2;
	Tx9.SelLength := 1;
end;

{
	Select 12.5 kHz channel spacing
}
procedure TForm1.N125kHz1Click(Sender: TObject);
begin
	ChanSpc := 12500;
	N125kHz1.Checked := True;
	N25kHz1.Checked := False;
	SaveConfig;
	DisplayChannels;
end;

{
	Select 25 kHz channel spacing
}
procedure TForm1.N25kHz1Click(Sender: TObject);
begin
	ChanSpc := 25000;
	N125kHz1.Checked := False;
	N25kHz1.Checked := True;
	SaveConfig;
	DisplayChannels;
end;

{
	Load channel file from disk
}
procedure TForm1.Load1Click(Sender: TObject);

var ChanFile: FILE of TChanConf;

begin
	if OpenDialog1.Execute then begin
		{$I-}
		AssignFile(ChanFile,OpenDialog1.Filename);
		Reset(ChanFile);
		Read(ChanFile,ChanConf);
		CloseFile(ChanFile);
		ChanSpc := ChanConf.ChanSpc;
		RxCh := ChanConf.RxCh;
		TxCh := ChanConf.TxCh;
		if ChanSpc = 25000 then begin
			N125kHz1.Checked := False;
			N25kHz1.Checked := True;
		end else begin
			N125kHz1.Checked := True;
			N25kHz1.Checked := False;
		end;
		DisplayChannels;
	end;
end;

{
	Save channel file to disk
}
procedure TForm1.Save1Click(Sender: TObject);

var ChanFile: FILE of TChanConf;

begin
	if SaveDialog1.Execute then begin
		GetFreq;
		ChanConf.ChanSpc := ChanSpc;
		ChanConf.RxCh := RxCh;
		ChanConf.TxCh := TxCh;
		{$I-}
		AssignFile(ChanFile,SaveDialog1.Filename);
		ReWrite(ChanFile);
		if IOResult = 0 then begin
			Write(ChanFile, ChanConf);
			CloseFile(ChanFile);
		end else begin
				Application.MessageBox('Can''t write channel file',
					'Errore!',MB_ICONSTOP or MB_OK);
		end;
		{$I+}
	end;
end;

{
	Check if entered frequency is valid
	Must be an integer multiple of the channel spacing
}
procedure Tform1.CheckFreq(EdBox: TmaskEdit);

var kHz, Hz: longint;
	 ErrC: integer;

begin
	Val(Copy(EdBox.Text, 5, 3), kHz, ErrC);
	Val(Copy(EdBox.Text, 9, 1), Hz, ErrC);
	if ((kHz*1000+100*Hz) mod ChanSpc) <> 0 then begin
		Application.MessageBox(
		'Invalid frequency (not an integer multiple of channel spacing)',
		'Error!', MB_ICONSTOP or MB_OK);
		EdBox.SetFocus;
		EdBox.SelStart := 2;
		EdBox.SelLength := 1;
	end;
end;

{
	Things to do when exiting from Rx and Tx frequency edit boxes
}
procedure TForm1.Rx0Exit(Sender: TObject);

begin
	CheckFreq(Rx0);
end;

procedure TForm1.Tx0Exit(Sender: TObject);
begin
	CheckFreq(Tx0);
end;

procedure TForm1.Rx1Exit(Sender: TObject);
begin
	CheckFreq(Rx1);
end;

procedure TForm1.Tx1Exit(Sender: TObject);
begin
	CheckFreq(Tx1);
end;

procedure TForm1.About1Click(Sender: TObject);
begin
	AboutBox.Visible := TRUE;
end;

procedure TForm1.Rx2Exit(Sender: TObject);
begin
	CheckFreq(Rx2);
end;

procedure TForm1.Tx2Exit(Sender: TObject);
begin
	CheckFreq(Tx2);
end;

procedure TForm1.Rx3Exit(Sender: TObject);
begin
	CheckFreq(Rx3);
end;

procedure TForm1.Tx3Exit(Sender: TObject);
begin
	CheckFreq(Tx3);
end;

procedure TForm1.Rx4Exit(Sender: TObject);
begin
	CheckFreq(Rx4);
end;

procedure TForm1.Tx4Exit(Sender: TObject);
begin
	CheckFreq(Tx4);
end;

procedure TForm1.Rx5Exit(Sender: TObject);
begin
	CheckFreq(Rx5);
end;

procedure TForm1.Tx5Exit(Sender: TObject);
begin
	CheckFreq(Tx5);
end;

procedure TForm1.Rx6Exit(Sender: TObject);
begin
	CheckFreq(Rx6);
end;

procedure TForm1.Tx6Exit(Sender: TObject);
begin
	CheckFreq(Tx6);
end;

procedure TForm1.Rx7Exit(Sender: TObject);
begin
	CheckFreq(Rx7);
end;

procedure TForm1.Tx7Exit(Sender: TObject);
begin
	CheckFreq(Tx7);
end;

procedure TForm1.Rx8Exit(Sender: TObject);
begin
	CheckFreq(Rx8);
end;

procedure TForm1.Tx8Exit(Sender: TObject);
begin
	CheckFreq(Tx8);
end;

procedure TForm1.Rx9Exit(Sender: TObject);
begin
	CheckFreq(Rx9);
end;

procedure TForm1.Tx9Exit(Sender: TObject);
begin
	CheckFreq(Tx9);
end;

{
	Get and show 40 bytes channel hexdump
}
procedure TForm1.HexDump1Click(Sender: TObject);

var p1,p2: pchar;
	 n: integer;
	 t:TDateTime;

begin
	p1 := RxBuf;
	p2 := RxBuf;
	FrHexDump.Memo1.Lines.Clear;
	ReadChannels;
	if StrLen(RxBuf) = 112 then begin
		while p1^ <> chr(0) do begin
			if p1^ = chr(13) then begin
				p1^ := chr(0);
				FrHexDump.Memo1.Lines.Add(StrPas(p2));
				inc(p1);
				p2 := p1;
			end else inc(p1);
		end;
		FrHexDump.Visible := TRUE;
		FrHexDump.BringToFront;
   end else begin
		Application.MessageBox('T7F not responding!','Warning', MB_OK);
   end;
end;

{
	Show GNU General Public License
}

procedure TForm1.GNULicense1Click(Sender: TObject);
begin
	GNULicense.Visible := TRUE;
end;

{
	Show T7F connectors pin assignment
}
procedure TForm1.Connectorspinout1Click(Sender: TObject);
begin
	FrPinout.Visible := TRUE;
end;

{
	Do not allow window resizing
}
procedure TForm1.FormResize(Sender: TObject);
begin
	Form1.Height := 460;
	Form1.Width :=  360;
end;

{
	Init ChanSpc and pd with default values
}
Initialization
	begin
		ChanSpc := 25000;
		pd := RxBuf;
	end;
end.
